<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item :label="t('mall.title')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="t('mall.pleaseEnterTitle')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> {{t('common.search')}}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> {{t('common.reset')}}</el-button>
        <el-button type="primary" @click="openForm('create')" v-hasPermi="['shop:service:create']">
          <Icon icon="ep:plus" class="mr-5px" /> {{t('action.add')}}
        </el-button>
        <!-- <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['shop:service:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> {{t('action.export')}}
        </el-button> -->
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list">
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column :label="t('mall.title')" align="center" prop="name" />
      <el-table-column :label="t('mall.icon')" align="center" prop="image">
        <template #default="scope">
          <el-image style="width: 100px; height: 100px" :src="scope.row.image"  />
        </template>
      </el-table-column>
      <el-table-column :label="t('mall.type')" align="center" prop="type">
        <template #default="scope">
         <span v-if="scope.row.type == 'pages'">{{t('mall.page')}}</span>
         <span v-if="scope.row.type == 'miniprogram'">{{t('mall.jumpToMiniProgram')}}</span>
         <span v-if="scope.row.type == 'call'">{{t('mall.phone')}}</span>
         <span v-if="scope.row.type == 'content'">{{t('mall.content')}}</span>
         <span v-else>{{ t('public.none') }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="t('mall.pagePath')" align="center" prop="pages" />
      <el-table-column :label="t('mall.phone')" align="center" prop="phone" />
      <el-table-column :label="t('mall.weight')" align="center" prop="weigh" />
      <el-table-column :label="t('public.status')" align="center" prop="status">
        <template #default="scope">
         <span v-if="scope.row.status == 1">{{ t('public.up') }}</span>
         <span v-else>{{ t('public.down') }}</span>
        </template>
      </el-table-column>
      <el-table-column
        :label="t('public.addTime')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="170"
      />
      <el-table-column :label="t('public.operate')" align="center" fixed="right" width="150">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['shop:service:update']"
          >
          {{t('action.edit')}}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['shop:service:delete']"
          >
          {{ t('public.delete') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ServiceForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts" name="Service">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as ServiceApi from '@/api/mall/shop/service'
import ServiceForm from './ServiceForm.vue'
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  name: null,
  image: null,
  type: null,
  content: null,
  pid: null,
  appId: null,
  pages: null,
  phone: null,
  weigh: null,
  status: null,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await ServiceApi.getServicePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ServiceApi.deleteService(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await ServiceApi.exportService(queryParams)
    download.excel(data, t('mall.myServiceXls'))
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
